﻿//using System;
//using System.Collections.Generic;
//using System.Collections.ObjectModel;
//using System.IO;
//using System.Linq;
//using System.Reflection;
//using System.Threading.Tasks;
//using Drivers;
//using Field_Test_8.Controllers;
//using MapControl.Extensions;
//using Microsoft.Data.Sqlite;
//using Newtonsoft.Json;
//using STILogger;
//using STITileMapCommonCore.Layers;
//using ThinkGeo.Core;

//namespace Quickstart
//{
//    public class TileLayer : SqliteFeatureLayer
//    {
//        public const string TILE_LAYER_KEY = "Tiles";
//        public const string TILE_POPUP_DISPLAY = "DisplayText";
//        public const string TILE_FEATURE_ID = "id";
//        public const string TILE_ID = "id";
//        public const string TILE_INDEX = "TileIndex";
//        public const string TILE_QUALITY = "Quality";
//        public const string TILE_GEOMETRY = "geometry";
//        public const string DATABASENAME = "tiles.db";

//        private Func<DriverDataPoint, DataPointValue.BarColor> _DataPointCalcFunc;
//        private static STILog _logger =
//            new STILog(MethodBase.GetCurrentMethod().DeclaringType);
//        private string lastConnectionString;

//        private TileLayer() : base()
//        {
//            FeatureSource = new TestSqliteFeatureSource();
//            DrawingExceptionMode = ThinkGeo.Core.DrawingExceptionMode.DrawException;
//        }

//        public TileLayer(string databasePath) : this()
//        {
//            if (!File.Exists(databasePath))
//            {
//                Directory.CreateDirectory(Path.GetDirectoryName(databasePath));
//                // File.Create(databasePath).Close();
//                SqliteFeatureSource.CreateDatabase(databasePath);
//                //SqliteConnection.CreateFile(databasePath);
//            }

//            this.DrawingExceptionMode = ThinkGeo.Core.DrawingExceptionMode.DrawException;
//            lastConnectionString = TileLayer.GetConnectionString(databasePath, false);
//            TableName = TILE_LAYER_KEY;
//            this.ConnectionString = lastConnectionString;
//            this.FeatureIdColumn = TILE_ID;
//            this.GeometryColumnName = TILE_GEOMETRY;
//            CheckIfTablesExist();
//            CreateValueStyles();
//            if (FeatureSource.IsOpen)
//            {
//            }
//            else
//            {
//                FeatureSource.Open();
//            }
//        }

//        ~TileLayer()
//        {
//            if (FeatureSource.IsOpen)
//            {
//                FeatureSource.Close();
//            }
//        }

//        public static string CombinePathDBName(string projectPath)
//        {
//            return Path.Combine(projectPath, DATABASENAME);
//        }

//        public void UpdateValueStyles()
//        {
//            CreateValueStyles();
//            this.RequestDrawing();
//        }

//        private void ApplyTileOpacity(Dictionary<string, AreaStyle> styles)
//        {
//            foreach (var key in styles.Keys)
//            {
//                var brush = styles[key].FillBrush;
//                if (brush is GeoSolidBrush)
//                {
//                    GeoSolidBrush solidBrush = (GeoSolidBrush)brush;
//                    solidBrush.Color.AlphaComponent = TileOpacity;
//                }

//                if (ShowOutline)
//                {
//                    styles[key].OutlinePen.Color.AlphaComponent = TileOpacity;
//                }
//                else
//                {
//                    styles[key].OutlinePen.Color.AlphaComponent = 0;
//                }
//            }
//        }

//        public void CreateValueStyles()
//        {
//            this.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear();
//            var ps = CreateAreaStyles();
//            var s = new Collection<ValueItem>();

//            foreach (string key in ps.Keys)
//            {
//                s.Add(new ValueItem(key, ps[key]));
//            }
//            var qualityValueStyle = new ValueStyle(TILE_QUALITY, s);
//            ZoomLevelSet.ZoomLevel01.CustomStyles.Add(qualityValueStyle);
//            ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
//        }

//        public GeoPen TileOutlinePen
//        {
//            get => MapController.Get().TileOutlinePen;
//        }

//        public byte TileOpacity
//        {
//            get => MapController.Get().TileOpacity;
//        }

//        private bool _showTileOutline = true;

//        public bool ShowOutline
//        {
//            get => _showTileOutline;
//            set
//            {
//                _showTileOutline = value;
//                CreateValueStyles();
//            }
//        }

//        public void RemoveAllTiles()
//        {
//            var feats = FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);
//            FeatureSource.BeginTransaction();
//            foreach (var f in feats)
//            {
//                FeatureSource.DeleteFeature(f.Id);
//            }

//            FeatureSource.CommitTransaction();
//        }

//        public void RemoveTile(int index)
//        {
//            var f = FeatureSource.GetFeaturesByColumnValue(TILE_INDEX, index.ToString(),
//                ReturningColumnsType.NoColumns);
//            if (f.Count > 0)
//            {
//                FeatureSource.BeginTransaction();
//                foreach (var dF in f)
//                {
//                    FeatureSource.DeleteFeature(index.ToString());
//                }

//                FeatureSource.CommitTransaction();
//            }
//        }

//        public bool IsFeatureLayer => true;

//        public int TileCount
//        {
//            get
//            {
//                if (FeatureSource != null)
//                {
//                    return FeatureSource.GetAllFeatures(ReturningColumnsType.NoColumns).Count;
//                }

//                return 0;
//            }
//        }

//        private Dictionary<string, AreaStyle> CreateAreaStyles()
//        {
//            Dictionary<string, AreaStyle> ret = new Dictionary<string, AreaStyle>();
//            var borderBrush = new GeoPen(new GeoSolidBrush(GeoColors.Black));

//            var iVals = MapController.Get().TileIntervals;
//            for (int i = 0; i < iVals?.Count; ++i)
//            {
//                var style = new AreaStyle
//                {
//                    FillBrush = new GeoSolidBrush(iVals[i].Color),
//                    OutlinePen = TileOutlinePen
//                };
//                ret.Add(i.ToString(), style);
//            }

//            var defStyle = new AreaStyle
//            {
//                FillBrush = new GeoSolidBrush(ConvertHTML(UIController.UnknownColor)),
//                OutlinePen = TileOutlinePen
//            };
//            ret.Add("-1", defStyle);
//            ApplyTileOpacity(ret);
//            return ret;
//        }

//        public TileLayer(string connectionString, string tableName, string featureIdColumnName,
//            string geometryColumnName) :
//            base(connectionString, tableName, featureIdColumnName, geometryColumnName)
//        {
//            TableName = tableName;
//            setProjection();
//            Open();
//            lastConnectionString = ConnectionString;

//            this.DrawingExceptionMode = ThinkGeo.Core.DrawingExceptionMode.DrawException;
//            DrawingQuality = ThinkGeo.Core.DrawingQuality.Default;
//            ZoomLevelSet = new STITileMap.GoogleMapsCoreZoomLevelSet();
//        }


//        private void CheckIfTablesExist()
//        {
//            bool createTable = false;



//            using (SqliteConnection conn = new SqliteConnection(lastConnectionString))
//            {

//                if (!CheckIfTableExists(conn, TILE_LAYER_KEY))
//                {
//                    CreateDataTable(conn);
//                    // SqliteFeatureSource.CreateSpatialIndex(conn, TILE_LAYER_KEY, GeometryColumnName, 3857);
//                }

//                //if (!CheckIfTableExists(conn, TILE_IDX_KEY))
//                //{
//                //    CreateDataIdxTable(conn);
//                //}

//                //if (!CheckIfTableExists(conn, TILE_IDX_NODE_KEY))
//                //{
//                //    CreateDataIdxNodeTable(conn);
//                //}

//                //if (!CheckIfTableExists(conn, TILE_IDX_PARENT_KEY))
//                //{
//                //    CreateDataIdxNodeParentTable(conn);
//                //}

//                //if (!CheckIfTableExists(conn, TILE_IDX_ROWID_KEY))
//                //{
//                //    CreateDataIdxNodeRowIdTable(conn);
//                //}
//            }
//        }

//        public bool CheckIfTableExists(SqliteConnection conn, string tablename)
//        {
//            string sql = string.Format("SELECT COUNT(*) FROM sqlite_master WHERE type = \"{0}\" AND name = \"{1}\"", "table", tablename);
//            if (conn.State == System.Data.ConnectionState.Closed) conn.Open();
//            using (SqliteCommand cmd = new SqliteCommand(sql, conn))
//            {
//                object res = cmd.ExecuteScalar();
//                if (res == null) return false;
//                int count = Convert.ToInt32(res);
//                conn.Close();
//                return count > 0;
//            }
//        }

//        public const string TILE_IDX_KEY = "idx_Tiles_Geometry";
//        public const string TILE_IDX_NODE_KEY = "idx_Tiles_Geometry_node";
//        public const string TILE_IDX_PARENT_KEY = "idx_Tiles_Geometry_parent";
//        public const string TILE_IDX_ROWID_KEY = "idx_Tiles_Geometry_rowid";


//        private void CreateDataIdxNodeRowIdTable(SqliteConnection conn)
//        {
//            if (conn.State == System.Data.ConnectionState.Closed) conn.Open();

//            string sql =
//                $"CREATE TABLE [{TILE_IDX_ROWID_KEY}] ([rowid] INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, [nodeno] bigint NULL);";
//            using (SqliteCommand command = new SqliteCommand(sql, conn))
//            {
//                command.ExecuteNonQuery();
//            }
//        }


//        private void CreateDataIdxNodeParentTable(SqliteConnection conn)
//        {
//            if (conn.State == System.Data.ConnectionState.Closed) conn.Open();

//            string sql =
//                $"CREATE TABLE [{TILE_IDX_PARENT_KEY}] ([nodeno] INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, [parentnode] bigint NULL);";
//            using (SqliteCommand command = new SqliteCommand(sql, conn))
//            {
//                command.ExecuteNonQuery();
//            }
//        }

//        private void CreateDataIdxTable(SqliteConnection conn)
//        {
//            if (conn.State == System.Data.ConnectionState.Closed) conn.Open();

//            string sql =
//                $"CREATE TABLE [{TILE_IDX_KEY}] ([id]  NULL, [minx]  NULL, [maxx]  NULL, [miny]  NULL, [maxy]  NULL);";
//            using (SqliteCommand command = new SqliteCommand(sql, conn))
//            {
//                command.ExecuteNonQuery();
//            }
//        }

//        private void CreateDataIdxNodeTable(SqliteConnection conn)
//        {
//            if (conn.State == System.Data.ConnectionState.Closed) conn.Open();

//            string sql =
//                $"CREATE TABLE [{TILE_IDX_NODE_KEY}] ([nodeno] INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, [data] image NULL);";
//            using (SqliteCommand command = new SqliteCommand(sql, conn))
//            {
//                command.ExecuteNonQuery();
//            }
//        }


//        private void CreateDataTable(SqliteConnection conn)
//        {
//            List<SqliteColumn> cols = new List<SqliteColumn>();
//            cols.Add(new SqliteColumn(TILE_INDEX, SqliteColumnType.Text));
//            cols.Add(new SqliteColumn("LAT", SqliteColumnType.Real));
//            cols.Add(new SqliteColumn("LON", SqliteColumnType.Real));
//            cols.Add(new SqliteColumn("COLOR", SqliteColumnType.Text));
//            cols.Add(new SqliteColumn("DISPLAYTEXT", SqliteColumnType.Text));
//            cols.Add(new SqliteColumn(TILE_QUALITY, SqliteColumnType.Text));
//            cols.Add(new SqliteColumn("MSG", SqliteColumnType.Text));
//            if (conn.State == System.Data.ConnectionState.Closed) conn.Open();
//            SqliteFeatureSource.CreateTable(conn, TILE_LAYER_KEY, cols, GeographyUnit.Meter);
//            //string sql = string.Format(
//            //    "Create Table {0} ({1} INTEGER PRIMARY KEY AUTOINCREMENT, {10} INTEGER, {2} TEXT, {3} DOUBLE, {4} DOUBLE, {5} TEXT, {6} TEXT, {7} TEXT,{8} TEXT, {9} BLOB);",
//            //    TILE_LAYER_KEY,
//            //    TILE_ID, TILE_INDEX, "LAT", "LON",
//            //    "COLOR", "DISPLAYTEXT", TILE_QUALITY, "MSG", TILE_GEOMETRY, TILE_FEATURE_ID);

//            //using (SqliteCommand command = new SqliteCommand(sql, conn))
//            //{
//            //    command.ExecuteNonQuery();
//            //}
//        }

//        private string _DatabaseName;

//        public string DatabaseName
//        {
//            get => _DatabaseName;
//            set
//            {
//                _DatabaseName = value;
//            }
//        }

//        public FeatureLayer GetFeatureLayer(string tableName, string databaseName, string displayName)
//        {
//            var host = new TileLayer(ConnectionString, tableName, FeatureIdColumn, GeometryColumnName)
//            {
//                DatabaseName = databaseName
//            };
//            //SqliteFeatureLayer sLayer = new SqliteFeatureLayer(ConnectionString, tableName, FeatureIdColumn, GeometryColumnName);
//            //sLayer.Name = AddDbName(sLayer.TableName);
//            //setProjection(sLayer);
//            //host.Layers.Add(sLayer.Name, sLayer);
//            host.setProjection();
//            host.Open();
//            if (!host.IsOpen)
//            {
//                var i = 0;
//                ++i;
//            }

//            return host;
//        }


//        public static string GetConnectionString(string dbLocation, bool readOnlydata)
//        {
//            string ret = null;
//            //ret = "Data Source=" + dbLocation + ";Read Only =" + readOnlydata.ToString();
//            ret = "Data Source=" + dbLocation + ";";
//            return ret;
//        }

//        protected void setProjection()
//        {
//            /*  Proj4Projection proj = new Proj4Projection();
//              proj.InternalProjectionParametersString = (Proj4Projection.GetEsriParametersString(srid));
//              proj.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
//              //proj.ExternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
//              FeatureSource.Projection = proj;
//              FeatureSource.Projection.Open();
//              if (!FeatureSource.Projection.IsOpen)
//              {
//                  int i = 0;
//                  ++i;
//              }
//              */

//            //this.FeatureSource.BeginTransaction();
//            //this.FeatureSource.
//            //this.FeatureSource.CommitTransaction();
//        }

//        private void setProjection(FeatureLayer layer)
//        {
//            /*Proj4Projection proj = new Proj4Projection();
//            proj.InternalProjectionParametersString = (Proj4Projection.GetEsriParametersString(srid));            
//            proj.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
//            //proj.ExternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
//            //layer.FeatureSource.Projection = proj;*/
//        }

//        //protected void SetWhereClause(StiSqliteFeatureLayer layer, ZoomLevel zoomLevel)
//        //{
//        //    var whereClause = string.Empty;

//        //    if (zoomLevel != null && zoomLevel.Name != string.Empty)
//        //        whereClause = zoomLevel.Name;
//        //    layer.WhereClause = whereClause;
//        //}

//        protected void SetWhereClause(FeatureLayer layer, ZoomLevel zoomLevel)
//        {
//            var whereClause = string.Empty;

//            if (zoomLevel != null && zoomLevel.Name != string.Empty)
//                whereClause = zoomLevel.Name;
//            ((SqliteFeatureLayer)layer).WhereClause = whereClause;
//        }

//        protected void SetWhereClause(FeatureLayer layer, string whereClause)
//        {
//            var sqlLayer = (TileLayer)layer;
//            sqlLayer.WhereClause = whereClause;
//        }

//        public void ClearCustomStyles()
//        {
//            /*if (ThinkGeoMapControl.useCustomZoolLevels)
//            {
//                for (int i = 0; i < (ThinkGeoMapControl.maxDefaultZoomLevels * ThinkGeoMapControl.zoomLevelMultiplier); ++i)
//                {
//                    ZoomLevelSet.CustomZoomLevels[i].CustomStyles.Clear();
//                }
//            }
//            else
//            { */
//            var zLevels = ZoomLevelSet.GetZoomLevels();
//            foreach (var z in zLevels) z.CustomStyles.Clear();
//            //}
//        }

//        internal class TileStruct
//        {
//            public string index;
//            public RectangleShape rect;
//            public int pointColor;
//            public string displayText;
//            public Dictionary<string, string> colData;
//        }

//        private void AddTiles(List<TileStruct> tiles)
//        {
//            FeatureSource.BeginTransaction();
//            foreach (var tile in tiles)
//            {
//                var colData = tile.colData;
//                var features = FeatureSource.GetFeaturesByColumnValue(TILE_INDEX, tile.index);
//                if (features.Count > 0)
//                {
//                    foreach (Feature f in features)
//                    {
//                        FeatureSource.DeleteFeature(f.Id);
//                        FeatureSource.AddFeature(tile.rect, colData);
//                    }
//                }
//                else
//                {
//                    FeatureSource.AddFeature(tile.rect, colData);
//                }
//            }
//            try
//            {
//                FeatureSource.CommitTransaction();
//            }
//            catch (SqliteException e)
//            {
//                _logger.Error(e);
//            }
//            catch (IndexOutOfRangeException e)
//            {
//                _logger.Error(e);
//            }
//        }

//        public void AddTile(int id, string index, RectangleShape rect,
//            int pointColor,
//            string displayText)
//        {
//            var colData = CreateTileColumnData(id, index, pointColor, displayText);

//            var features = FeatureSource.GetFeaturesByColumnValue(TILE_INDEX, index);
//            if (features.Count > 0)
//            {
//                FeatureSource.BeginTransaction();
//                foreach (Feature f in features)
//                {
//                    FeatureSource.DeleteFeature(f.Id);
//                    FeatureSource.AddFeature(rect, colData);
//                }

//                FeatureSource.CommitTransaction();
//            }
//            else
//            {
//                FeatureSource.BeginTransaction();
//                FeatureSource.AddFeature(rect, colData);
//                FeatureSource.CommitTransaction();
//            }
//        }

//        public void DrawTile(RectangleShape rect, int id,
//            int Index, int pointColor, string displayText)
//        {
//            DrawTileCore(rect, id, Index.ToString(), pointColor, displayText);
//        }


//        public async void DrawTile(RectangleShape currentExtent, double widthX, double widthY, DataPointsLayer dl)
//        {
//            //var rect =  currentExtent.GetMinMaxDimensions();
//            //var horiInterval = (rightLineLimit - leftLineLimit) / widthX;
//            //var vertInterval = (topLineLimit - botLineLimit) / widthY;
//            double leftLineLimit = 0.0;
//            double rightLineLimit = 0.0;
//            double topLineLimit = 0.0;
//            double botLineLimit = 0.0;

//            currentExtent.GetMinMaxDimensions(ref topLineLimit, ref rightLineLimit, ref botLineLimit,
//                ref leftLineLimit);

//            List<double> xLine = new List<double>();
//            List<double> yLine = new List<double>();

//            var xT = leftLineLimit;
//            while (xT < rightLineLimit)
//            {
//                xLine.Add(xT);
//                xT += widthX;
//            }

//            var yT = botLineLimit;
//            while (yT < topLineLimit)
//            {
//                yLine.Add(yT);
//                yT += widthY;
//            }

//            yLine.Reverse();

//            List<TileStruct> ret = await Task.Run(() =>
//            {
//                List<TileStruct> tiles = new List<TileStruct>();

//                for (int i = 0; (i + 1) < xLine.Count; ++i)
//                {
//                    var leftLine = xLine[i];
//                    var rightLine = xLine[i + 1];
//                    //Y
//                    for (int j = 0; (j + 1) < yLine.Count; ++j)
//                    {
//                        var topLine = yLine[j];
//                        var botLine = yLine[j + 1];
//                        //RectangleShape rTile = 
//                        var tile = new RectangleShape(new PointShape(leftLine, topLine),
//                            new PointShape(rightLine, botLine));

//                        var id = (yLine.Count * i + j);
//                        tile.Id = id.ToString();
//                        TileStruct ts = new TileStruct();
//                        ts.index = tile.Id;
//                        ts.rect = tile;
//                        ts.displayText = tile.Id;
//                        ts.pointColor = GetTileQuality(tile);
//                        ts.colData = CreateTileColumnData(id, ts.index, ts.pointColor, ts.displayText);
//                        tiles.Add(ts);
//                        //AddTile(tile.Id, tile, GetTileQuality(tile), tile.Id.ToString());
//                        //TileQueuedEvent ev = new TileQueuedEvent(tile, int.Parse(tile.Id));
//                        //eventQueue.Enqueue(ev);
//                    }
//                }

//                return tiles;
//            });

//            RemoveAllTiles();
//            AddTiles(ret);

//        }

//        //public void DrawTiles(IEnumerable<RectangleShape> rectangles,
//        //    int StartIndex)
//        //{
//        //    int i = StartIndex;
//        //    foreach (RectangleShape rect in rectangles)
//        //    {
//        //        DrawTileCore(rect, i);
//        //        ++i;
//        //    }
//        //}

//        public void DrawTileCore(PointShape TopLeft, PointShape BottomRight, int id, int Index,
//            int pointColor, string displayText)
//        {
//            // RectangleShape rectangle = new RectangleShape(TopLeft.ToMeters(), BottomRight.ToMeters());
//            DrawTileCore(new RectangleShape(TopLeft, BottomRight), id, Index.ToString(), pointColor, displayText);
//        }

//        public void DrawTileCore(RectangleShape tileFeature, int id, string Index,
//            int pointColor, string displayText)
//        {
//            var cols = CreateTileColumnData(id, Index, pointColor, displayText);
//            AddFeature(tileFeature, cols);
//        }

//        private Dictionary<string, string> CreateTileColumnData(int id, string index,
//            int pointColor, string displayText)
//        {
//            Dictionary<string, string> TILEColumnData = new Dictionary<string, string>
//            {
//               {TILE_INDEX, index}, {TILE_POPUP_DISPLAY, displayText}, {TILE_QUALITY, pointColor.ToString()}, {TILE_FEATURE_ID, id.ToString()}
//            };
//            return TILEColumnData;
//        }

//        //public delegate TResult Func<in T, out TResult>(T arg);

//        //private Action<DriverDataPoint> _onDataPointClickFunc;

//        //public void SetDataPointCalc(
//        //    Func<DriverDataPoint, DriverDataPoint.Types.DataPointValue.Types.BarColor> calcFunc)
//        //{
//        //    _DataPointCalcFunc = calcFunc;
//        //}

//        //public void SetDataPointClickFunc(Action<DriverDataPoint> signalFunc)
//        //{
//        //    _onDataPointClickFunc = signalFunc;
//        //}

//        //public void OnDataPointClick(DriverDataPoint dp)
//        //{
//        //    if (_onDataPointClickFunc != null)
//        //    {
//        //        _onDataPointClickFunc(dp);
//        //    }
//        //}

//        //public Collection<string> GetDataPointIdsContainedInTile(Feature tile)
//        //{
//        //    var map = MapController.Get();
//        //    var dl = map.DataPointsLayer;
//        //    if (!dl.IsOpen)
//        //    {
//        //        dl.Open();
//        //    }

//        //    if (!dl.FeatureSource.IsOpen)
//        //    {
//        //        dl.FeatureSource.Open();
//        //    }

//        //    Collection<string> ids = dl.FeatureSource.GetFeatureIdsInsideBoundingBox(tile.GetBoundingBox());
//        //    dl.FeatureSource.Close();
//        //    dl.Close();

//        //    return ids;
//        //}

//        public int DoCalcOnDataPoints(List<DriverDataPoint> msgs)
//        {
//            var calcFunc = MapController.Get().TilingFunction;
//            if (calcFunc == null)
//            {
//                return -1;
//            }
//            else
//            {
//                return calcFunc.TileCalc(msgs);
//            }
//        }

//        private void AddFeature(BaseShape newFeat, Dictionary<string, string> colData)
//        {
//            var features = FeatureSource.GetFeaturesByColumnValue(TILE_INDEX, colData[TILE_INDEX]);
//            if (features.Count > 0)
//            {
//                FeatureSource.BeginTransaction();
//                foreach (Feature f in features)
//                {
//                    FeatureSource.DeleteFeature(f.Id);
//                    FeatureSource.AddFeature(newFeat, colData);
//                }

//                FeatureSource.CommitTransaction();
//            }
//            else
//            {
//                FeatureSource.BeginTransaction();
//                FeatureSource.AddFeature(newFeat, colData);
//                FeatureSource.CommitTransaction();
//            }
//        }

//        public void CalculateQualityOnAllTiles()
//        {
//            var feats = FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);
//            try
//            {
//                foreach (var f in feats)
//                {
//                    UpdateTileQuality(f);
//                }
//            }
//            catch (Exception ex)
//            {
//                _logger.Error(ex);
//            }
//        }

//        private int GetTileQuality(RectangleShape tile)
//        {
//            int ret = -1;
//            var dataPoints = ProjectController.Get().SelectedProject?.DataPoints;
//            if (dataPoints != null)
//            {
//                var dataPointsList = dataPoints.FeatureSource.GetFeaturesInsideBoundingBox(tile,
//                    ReturningColumnsType.AllColumns);

//                List<DriverDataPoint> data = new List<DriverDataPoint>(dataPointsList.Count);
//                foreach (var ft in dataPointsList)
//                {
//                    try
//                    {
//                        string rawMsg = ft.ColumnValues[DataPointsLayer.DATAPOINT_MSG];
//                        DriverDataPoint dp = JsonConvert.DeserializeObject<DriverDataPoint>(rawMsg);
//                        data.Add(dp);
//                    }
//                    catch (Exception e)
//                    {
//                        _logger.Error(e);
//                    }
//                }

//                ret = DoCalcOnDataPoints(data);
//            }

//            return ret;
//        }

//        private void UpdateTileQuality(Feature tile)
//        {
//            var qual = GetTileQuality(tile.GetBoundingBox());
//            if (String.CompareOrdinal(tile.ColumnValues[TILE_QUALITY], qual.ToString()) == 0)
//            {
//            }
//            else
//            {
//                tile.ColumnValues[TILE_QUALITY] = qual.ToString();
//                FeatureSource.BeginTransaction();
//                FeatureSource.UpdateFeature(tile.GetShape(), tile.ColumnValues);
//                FeatureSource.CommitTransaction();
//            }
//        }


//        public void AddedDataPoint(Feature pt)
//        {
//            var feats = FeatureSource.GetFeaturesInsideBoundingBox(pt.GetBoundingBox(),
//                ReturningColumnsType.AllColumns);
//            try

//            {
//                foreach (var f in feats)
//                {
//                    UpdateTileQuality(f);
//                }
//            }
//            catch (Exception ex)
//            {
//                _logger.Error(ex);
//            }
//        }

//        private void UpdateFeature(Feature old, Feature feat)
//        {
//            AddFeature(feat.GetShape(), old.ColumnValues);
//        }

//        private void UpdateFeature(Feature old, Dictionary<string, string> colData)
//        {
//            AddFeature(old.GetShape(), colData);
//        }

//        private GeoColor ConvertHTML(string htmlColor)
//        {
//            var color = System.Drawing.ColorTranslator.FromHtml(htmlColor);
//            return new GeoColor(color.A, color.R, color.G, color.B);
//        }

//        private string ConvertGeoToHtml(GeoColor g)
//        {
//            return g.HtmlColor;
//        }

//        protected override void DrawCore(GeoCanvas canvas, Collection<SimpleCandidate> labelsInAllLayers)
//        {
//            try
//            {
//                base.DrawCore(canvas, labelsInAllLayers);
//            }
//            catch (Exception e)
//            {
//                _logger.Error(e);
//            }
//        }
//    }
//}
